//26/06/2000
//IMPLEMENTA IL DEMONE DI CRASH
import java.net.*;
import java.io.*;

public class DeamonCrash extends Thread
	{
	private ObjectInputStream SuccRD;	//stream di lettura sul successore
	private ObjectOutputStream PrecWR;	//stream di scrittura sul predecessore
	private ServerConfig HostConfig;
	
	DeamonCrash(ServerConfig c)
		{
		super("DEAMON CRASH");
		HostConfig=c;
		SuccRD=null;
		PrecWR=null;
		}
		
	public synchronized void redefineSuccHost()		{SuccRD=HostConfig.getSuccRD();}
	public synchronized void redefinePrecHost()		{PrecWR=HostConfig.getPrecWR();}
	
	public void run()
		{
		Log.netLogging("@@@@@@ "+getName()+": Active!!");
		while (true)		//ciclo infinito
			{
			try {
			byte typemsg=-1;
			boolean reread=true;
			while (reread) 
				{
				try {
				typemsg=SuccRD.readByte();
				reread=false;
					}
				catch (SocketException e) {;} //ridefinizione socket durante la sospensione}
				}
			if (Message.decodeMsg(typemsg).equals("CSD"))
				{//messaggio di CRASH_SERVER_DETECT
				MsgCrashServerDetect rmsg=(MsgCrashServerDetect) SuccRD.readObject();
				if (rmsg.getIPaddrCrash().equals(HostConfig.getPrecHost().getHostAddress()))
					{//il predecessore  il server in crash
					//sicuramente ancora almeno 2 server nel sistema
					//richiesta di connessione alla socket di connessione
					Socket NewSock=new Socket(InetAddress.getByName(rmsg.getIPaddrRilevator()), CServer.PORTNEW);
					//ridefinizioni socket di connessione con il predecessore
				/**/	HostConfig.setPrecSock(NewSock);
				/**/	ObjectOutputStream pwr=new ObjectOutputStream(NewSock.getOutputStream());
				/**/	pwr.flush();
				/**/	ObjectInputStream prd=new ObjectInputStream(NewSock.getInputStream());
				/**/	HostConfig.setPrecWR(pwr);
				/**/	HostConfig.setPrecRD(prd);
					HostConfig.getDeamonBook().redefinePrecHost();
					HostConfig.getDeamonNetwork().redefinePrecHost();
					redefinePrecHost();
					Log.netLogging(getName()+": redefine predecessor");
					Log.netLogging("%% "+NewSock.toString());
					}
				else
					{//forword del CRASH_SERVER_DETECT
					synchronized (PrecWR)
						{
						PrecWR.writeByte(Message.codeMsg("CSD"));
						PrecWR.writeObject(rmsg);
						PrecWR.flush();
						}
					Log.netLogging(getName()+": forword CRASH_SERVER_DETECT");
					Log.netLogging("%% "+HostConfig.getPrecSock().toString());
					}
				}
			else
				Log.netLogging("($$$) [ERROR] "+getName()+" receive message, not CRASH_SERVER_DETECT");
				//bisogna fermare il server!!!!!
			}//end try
			catch (OptionalDataException e) 	{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION] "+getName()+" "+e); stop();}
			catch (ClassNotFoundException e) 	{Log.netLogging("($$$) [READ OBJECT STREAM EXCEPTION] "+getName()+" "+e); stop();}
			catch (UnknownHostException e)		{Log.netLogging("($$$) [ADDRESS HOST EXCEPTION] "+getName()+" "+e); stop();}
			catch (StreamCorruptedException e) 	{Log.netLogging("($$$) [NEW INPUT STREAM EXCEPTION] "+getName()+" "+e); stop();}
			catch (EOFException e)			{/*ignored*/}
			catch (IOException e) 			{Log.netLogging("($$$) [READ STREAM EXCEPTION] "+getName()+" "+e); stop();}
			}//end while
		}
	
	}