//ult. rev. 27/07/2000
//IMPLEMENTA IL DEMONE DI ASCOLTO PER EFFETTUARE INSERIMENTI DI NUOVI SERVER
import java.io.IOException;
import java.net.*;

public class DeamonInsert extends Thread
	{
	private ServerConfig HostConfig;		//riferimento alla configurazione del server
	
	DeamonInsert(ServerConfig s)		
		{super("DEAMON INSERT");		HostConfig=s;}
		
	public void run()
		{
		try {	Log.netLogging("@@@@@@ "+getName()+": Active!!");
			//socket d'ascolto inserimenti nuovi server
			ServerSocket InsSock=new ServerSocket(CServer.PORTINS);
			Log.netLogging(getName()+": created socket listen at "+CServer.PORTINS);
			Socket NewSock;
			while (true)			//ciclo infinito
				{
				//accettazione inserimento		
				NewSock=InsSock.accept();
				Log.netLogging(getName()+": accept server insert");
				Log.netLogging("%% "+NewSock.toString());
				//crazione e lancio ThreadInsert corrispondente
				ThreadInsert ti=new ThreadInsert(NewSock, HostConfig);
				ti.start();
				//attesa terminazione ThreadInsert
				try {ti.join();}
				catch (InterruptedException ei) {/*ignored*/}
				}//end while
			}//end try
		catch (IOException e) {Log.netLogging("($$$) "+getName()+": "+e);}
		}
	}
