//ult. rev. 27/07/2000
//IMPLEMENTA IL DEMONE DI ASCOLTO SULLA PORTA DI RICHIESTA DEI  SERVIZI (7777)
import java.net.*;
import java.io.IOException;
//realizza il demone delle richieste
public class DeamonRequest extends Thread
	{
	private ServerConfig HostConfig;		//riferimento alla configurazione del server
	ServerSocket LstSock;			//socket di accettazione richiesta
	
	DeamonRequest(ServerConfig c)		
		{super("DEAMON REQUEST");	HostConfig=c;}

	public void run()
		{
		try {	Log.netLogging("@@@@@@ "+getName()+": Active!!");
			//creazione socket di ascolto - PORTRQ
			LstSock=new ServerSocket(CServer.PORTRQ);
			Log.netLogging(getName()+" listen at "+CServer.PORTRQ);
			while (true)	//funzionamento infinito
				{
				//accettazione servizio con generazione di una nuova socket
				//per comunicare con il client
				Socket srvsock=LstSock.accept();
				Log.netLogging(getName()+" accept client");
				Log.netLogging("%% "+srvsock.toString());
				//creazione del thread di servizio e relativa esecuzione 
				ThreadService service=new ThreadService(srvsock, HostConfig);
				service.start();
				}
			}
		catch (BindException e) {Log.netLogging("($$$) "+getName()+": port "+CServer.PORTRQ+" in use ");}
		catch (IOException e) 	{Log.netLogging("($$$) "+getName()+": general error "+e);}
		}
	}