//13/06/2000
//IMPLEMETNA  LE INFORMAZIONI COMPLETE DI UN VOLO

import ClientAttrib;
import FlightAttrib;
import java.io.Serializable;
public class Flight implements Serializable
//IMPLEMENTA UNA ENTRY DEL DATABASE (volo + posti)
	{
	private int MAX_NUM_ROW;
	//numero massimo di file del volo
	private int MAX_NUM_NUM;
	//numero massimo posti per fila del volo
	private FlightAttrib Fly;
	//attributi del volo
	private ClientAttrib Book[][];
	//prenotazioni del volo
	
	Flight()
		{
		Fly=new FlightAttrib();
		MAX_NUM_NUM=6;
		MAX_NUM_ROW=10;
		Book=new ClientAttrib[MAX_NUM_ROW][MAX_NUM_NUM];
		for (int i=0; i<MAX_NUM_ROW; i++)
			for (int j=0; j<MAX_NUM_NUM; j++)
				Book[i][j]=new ClientAttrib();
		}
	Flight(FlightAttrib f)
		{
		Fly=f;
		MAX_NUM_NUM=6;
		MAX_NUM_ROW=10;
		Book=new ClientAttrib[MAX_NUM_ROW][MAX_NUM_NUM];
		for (int i=0; i<MAX_NUM_ROW; i++)
			for (int j=0; j<MAX_NUM_NUM; j++)
				Book[i][j]=new ClientAttrib();
		}
	Flight(int nrow, int nnum)
		{
		Fly=new FlightAttrib();
		MAX_NUM_ROW=nrow;
		MAX_NUM_NUM=nnum;
		Book=new ClientAttrib[MAX_NUM_ROW][MAX_NUM_NUM];
		for (int i=0; i<MAX_NUM_ROW; i++)
			for (int j=0; j<MAX_NUM_NUM; j++)
				Book[i][j]=new ClientAttrib();
		}
	Flight(FlightAttrib f, int nrow, int nnum)
		{
		MAX_NUM_ROW=nrow;
		MAX_NUM_NUM=nnum;
		Fly=f;
		Book=new ClientAttrib[MAX_NUM_ROW][MAX_NUM_NUM];
		for (int i=0; i<MAX_NUM_ROW; i++)
			for (int j=0; j<MAX_NUM_NUM; j++)
				Book[i][j]=new ClientAttrib();
		}
		
	public int getNumRow()
		{return MAX_NUM_ROW;}
	public int getNumNum()
		{return MAX_NUM_NUM;}
		
	public FlightAttrib getFlightAttrib()
	//RESTITUISCE GLI ATTRIBUTI DEL VOLO
		{return Fly;}
	public ClientAttrib[][] getBook()
	//RESTITUISCE L'INTERA MAPPATURA DEI POSTI DEL VOLO
		{return Book;}	
	public ClientAttrib getClientAttrib(int r, int n) throws Exception
	//RESTITUISCE LE SPECIFICHE DEL CLIENTE CHE HA PRENOTATO
	//bisogna poi controllare (isNull()) se sono significative
		{
		if ((r<MAX_NUM_ROW) & (n<MAX_NUM_NUM))
			return Book[r][n];
		else
			throw new ArrayIndexOutOfBoundsException("FlyBook: Invalid Seat Code");
		}
		
	public boolean isBook(int r, int n) throws Exception
	//CONTROLLA SE UN POSTO E' PRENOTATO (true)
		{
		if ((r<MAX_NUM_ROW) & (n<MAX_NUM_NUM) & (r>=0) & (n>=0))
			{
			if (Book[r][n].getClientKey().getKey()>0)
				return true;
			else	
				return false;
			}
		else
			throw new ArrayIndexOutOfBoundsException("FlyBook: Invalid Seat Code");
		}
		
	public synchronized void setFlightAttrib(FlightAttrib fa)
		{Fly=fa;}
		
	public synchronized void setClientAttrib(ClientAttrib c, int r, int n) throws Exception
		{
		if ((r<MAX_NUM_ROW) & (n<MAX_NUM_NUM) & (r>=0) & (n>=0))
			Book[r][n]=c;
		else
			throw new ArrayIndexOutOfBoundsException("FlyBook: Invalid Seat Code");
		}
		
	public synchronized boolean addBook(ClientAttrib ca, int r, int n) throws Exception
	//AGGIUNGE UNA PRENOTAZIONE AL VOLO (true se tutto  andato bene - posto era libero)
		{
		if ((r<MAX_NUM_ROW) & (n<MAX_NUM_NUM) & (r>=0) & (n>=0))
			{
			if (isBook(r, n))
				return false;
			else
				{
				Book[r][n]=ca;
				return true;
				}
			}
		else
			throw new ArrayIndexOutOfBoundsException("FlyBook: Invalid Seat Code");
		}
		
	public synchronized void delBook(int r, int n) throws Exception
	//CANCELLA UNA PRENOTAZIONE DI UN POSTO PER IL VOLO
		{
		if ((r<MAX_NUM_ROW) & (n<MAX_NUM_NUM))
			Book[r][n]=new ClientAttrib();
		else
			throw new ArrayIndexOutOfBoundsException("FlyBook: Invalid Seat Code");
		}
	public int[] getClientSeat(ClientKey k)
		{
		int ro=getNumRow();
		int nu=getNumNum();
		int[] app1=new int[ro*nu*2];
		int indsea=0;
		for (int r=0; r<ro; r++)
			for (int n=0; n<nu; n++)
				{
				try {
					if (getClientAttrib(r,n).getClientKey().getKey()==k.getKey())
						{
						app1[indsea]=r;
						indsea++;
						app1[indsea]=n;
						indsea++;
						}
					}
				catch (Exception e) { }
				}
		int[] app=new int[indsea];
		for (int y=0; y<indsea; y++)
			app[y]=app1[y];	
		return app;
		}
					
	}	
