//
//IMPLEMENTA L'INTERFACCIA DEL SERVER
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.Date;

public class InterfaceServer extends Thread
	{
	InterfaceServer()	{super("INTERFACE SERVER");}
	/* finestra di log per le connessioni tra server */
	protected Frame winLOG;
		protected TextArea taLOG;
	/* finestra di log dello stato dei servizi */
	protected Frame winSRVLOG;
		protected TextArea taSRVLOG;
	//finestra di inserimento indirizzo
	protected Frame winADDR;
		protected TextField tfADDR;
	//finestra principale
	protected Frame winCON;
	//finestra di operativit
	protected Frame winOPS;
	//machera di insert
	protected Frame winINS;
		protected TextField tfcodeINS;
		protected TextField tfpartINS;
		protected TextField tfarrINS;
		protected TextField tfdatINS;
	//maschera di delete
	protected Frame winDEL;
		protected TextField tfcodeDEL;
		
	protected ServerConfig HostConfig;
	protected String IPaddrInsert;
	protected Db database;
	
	public void Ender()
		{
		try {winOPS.dispose();}
		catch (Exception e) {/*ignored*/}
		try {winINS.dispose();}
		catch (Exception e) {/*ignored*/}
		try {winADDR.dispose();}
		catch (Exception e) {/*ignored*/}
		try {winDEL.dispose();}
		catch (Exception e) {/*ignored*/}
		winCON.setEnabled(true);
		winCON.show();
		}
		
	protected Frame createWinErr(String s)
		{
		Frame f=new Frame();
		f.setLocation(200,200);
		f.setSize(300,100);
		f.setBackground(Color.red);
		f.setLayout(new BorderLayout());
		f.setFont(new Font("TimensRomans", Font.BOLD, 16));
		Button bok=new Button("OK");
		GestEs hand=new GestEs(f);
		bok.addActionListener(hand);
		Label lerr=new Label(s, Label.CENTER);
		f.add("Center", lerr);
		f.add("South", bok);
		return f;
		}
		
	public void createWinADDR()
		{
		Frame f=new Frame();
		f.setLocation(200,200);
		f.setSize(400,100);
		f.setBackground(Color.orange);
		f.setLayout(new FlowLayout());
		f.setFont(new Font("TimensRomans", Font.BOLD, 16));
		Button bokADDR=new Button("OK");
		tfADDR=new TextField("192.168.0.22");
		tfADDR.setBackground(Color.white);
		Label lADDR=new Label("Host Addres for insert", Label.CENTER);
		GestButtonADDR hand=new GestButtonADDR(this);
		bokADDR.addActionListener(hand);
		f.add(lADDR);
		f.add(tfADDR);
		f.add(bokADDR);
		winADDR=f;
		}

	public void createWinCON()
		{
		winCON=new Frame("Inizializzazione server");
		winCON.setLocation(300,150);
		winCON.setSize(300,200);
		winCON.setResizable(false);
		winCON.setBackground(Color.orange);
		winCON.setLayout(new GridLayout(4,1,0,10));
		winCON.setFont(new Font("TimesRomans", Font.PLAIN, 14));
		Button bunicCON=new Button("Server Unico");
		Button binsCON=new Button("Inserisci Server nel Sistema");
		Button bescCON=new Button("ESCI");
		GestButtonCON bhandleCON=new GestButtonCON(this);
		bunicCON.addActionListener(bhandleCON);
		binsCON.addActionListener(bhandleCON);
		bescCON.addActionListener(bhandleCON);
		Label lintCON=new Label("AMMINISTRAZIONE SERVER", Label.CENTER);
		lintCON.setFont(new Font("TimesRomans", Font.BOLD, 18));
		winCON.add(lintCON);
		winCON.add(bunicCON);
		winCON.add(binsCON);
		winCON.add(bescCON);
		}
		
	public void createWinOPS()
		{
		winOPS=new Frame("GESTIONE VOLI");
		winOPS.setLocation(300,100);
		winOPS.setLayout(new GridLayout(5,1,0,5));
		winOPS.setSize(300,300);
		winOPS.setResizable(false);
		winOPS.setBackground(Color.orange);
		winOPS.setFont(new Font("TimesRomans", Font.PLAIN, 14));
		Button bdiscOPS=new Button("Disconnetti server");
		Button binsOPS=new Button("Inserisci nuovo volo");
		Button bdelOPS=new Button("Cancella volo effettuato");
		GestButtonOPS bhandleOPS=new GestButtonOPS(this);
		bdiscOPS.addActionListener(bhandleOPS);
		binsOPS.addActionListener(bhandleOPS);
		bdelOPS.addActionListener(bhandleOPS);
		Label llineOPS=new Label("__________________________", Label.CENTER);
		llineOPS.setFont(new Font("TimesRomans", Font.BOLD, 26));
		winOPS.add(new Label(" "));
		winOPS.add(bdiscOPS);
		winOPS.add(llineOPS);
		winOPS.add(binsOPS);
		winOPS.add(bdelOPS);
		}
	
	public void createWinINS()
		{
		winINS=new Frame("Inserimento nuovo volo");
		winINS.setLocation(200,100);
		winINS.setLayout(new GridLayout(5,2,10,30));
		winINS.setSize(600,300);
		winINS.setResizable(false);
		winINS.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winINS.setBackground(Color.orange);
		Label lcodeINS=new Label("Codice volo", Label.CENTER);
		Label lpartINS=new Label("Luogo di partenza", Label.CENTER);
		Label larrINS=new Label("Luogo di arrivo", Label.CENTER);
		Label ldatINS=new Label("Giorno e ora di partenza", Label.CENTER);
		tfcodeINS=new TextField(19);
		tfcodeINS.setBackground(Color.white);
		tfpartINS=new TextField(30);
		tfpartINS.setBackground(Color.white);
		tfarrINS=new TextField(30);
		tfarrINS.setBackground(Color.white);
		tfdatINS=new TextField(14);
		tfdatINS.setBackground(Color.white);
		tfdatINS.setText("Sat, 12 Aug 1995 13:30:00 GMT");
		Button bokINS=new Button("OK");
		Button bannINS=new Button("ANNULLA");
		GestButtonINS bhandleINS=new GestButtonINS(this);
		bokINS.addActionListener(bhandleINS);
		bannINS.addActionListener(bhandleINS);
		winINS.add(lcodeINS);
		winINS.add(tfcodeINS);
		winINS.add(lpartINS);
		winINS.add(tfpartINS);
		winINS.add(larrINS);
		winINS.add(tfarrINS);
		winINS.add(ldatINS);
		winINS.add(tfdatINS);
		winINS.add(bokINS);
		winINS.add(bannINS);
		}	
		
	public void createWinDEL()
		{
		winDEL=new Frame("Cancellazione volo");
		winDEL.setLocation(250,150);
		winDEL.setLayout(new GridLayout(2,2,10,20));
		winDEL.setSize(400,100);
		winDEL.setResizable(false);
		winDEL.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winDEL.setBackground(Color.orange);
		Label lcodeDEL=new Label("Codice volo", Label.CENTER);
		tfcodeDEL=new TextField(19);
		tfcodeDEL.setBackground(Color.white);
		Button bokDEL=new Button("OK");
		Button bannDEL=new Button("ANNULLA");
		GestButtonDEL bhandleDEL=new GestButtonDEL(this);
		bokDEL.addActionListener(bhandleDEL);
		bannDEL.addActionListener(bhandleDEL);
		winDEL.add(lcodeDEL);
		winDEL.add(tfcodeDEL);
		winDEL.add(bokDEL);
		winDEL.add(bannDEL);
		}
		
	public void createWinLOG()
		{
		winLOG=new Frame("SERVER STATUS LOG");
		winLOG.setLocation(600,20);
		winLOG.setSize(400,700);
		winLOG.setBackground(Color.white);
		winLOG.setFont(new Font("TimesRomans", Font.PLAIN, 10));
		taLOG=new TextArea();
		winLOG.add(taLOG);
		}
		
	public void createWinSRVLOG()
		{
		winSRVLOG=new Frame("SERVICE STATUS LOG");
		winSRVLOG.setLocation(620,40);
		winSRVLOG.setSize(400,700);
		winSRVLOG.setBackground(Color.white);
		winSRVLOG.setFont(new Font("TimesRomans", Font.PLAIN, 10));
		taSRVLOG=new TextArea();
		winSRVLOG.add(taSRVLOG);
		}
		
	public void initServer()
		{
		HostConfig=new ServerConfig();
		HostConfig.setDeamonNetwork(new DeamonNetwork(HostConfig));
		HostConfig.getDeamonNetwork().setDaemon(true);
		HostConfig.setDeamonCrash(new DeamonCrash(HostConfig));
		HostConfig.getDeamonCrash().setDaemon(true);
		HostConfig.setDeamonInsert(new DeamonInsert(HostConfig));
		HostConfig.getDeamonInsert().setDaemon(true);
		HostConfig.setDeamonRequest(new DeamonRequest(HostConfig));
		HostConfig.getDeamonRequest().setDaemon(true);
		HostConfig.setDeamonCrashDetect(new DeamonCrashDetect(HostConfig));
		HostConfig.getDeamonCrashDetect().setDaemon(true);
		HostConfig.setDeamonBook(new DeamonBook(HostConfig));
		HostConfig.getDeamonBook().setDaemon(true);
		HostConfig.setApplication(this);
		Log.setNetLog(taLOG);
		Log.setSrvLog(taSRVLOG);
		}
		
	public void run()
		{
		createWinADDR();
		createWinCON();
		createWinOPS();
		createWinINS();
		createWinDEL();
		createWinLOG();
		createWinSRVLOG();
		initServer();
		winCON.show();
		winLOG.show();
		winSRVLOG.show();
		try {Log.netLogging("Server at: "+InetAddress.getLocalHost().getHostAddress()+"\n");}
		catch(UnknownHostException e) { }
		try {Log.srvLogging("Server: "+InetAddress.getLocalHost().getHostAddress()+"\n");}
		catch (UnknownHostException e) {}
		}
	}
	
class GestButtonCON implements ActionListener
	{
	private InterfaceServer IS;	
	GestButtonCON(InterfaceServer t)
		{IS=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Server Unico"))
			{
			try	{
				IS.winCON.setEnabled(false);
				//settaggio server unico
				IS.HostConfig.getUnic().TurnOn();
				Log.netLogging("(! ! !) Server UNIC-ON");
				IS.HostConfig.setDatabase(GestDBLocal.Load());
				Log.netLogging("Database load....");
				//lancio demoni di insert e request
				Log.netLogging("Daemon Request & Insert started....");
				IS.HostConfig.getDeamonInsert().start();
				IS.HostConfig.getDeamonRequest().start();
				IS.winCON.dispose();
				IS.winCON.setEnabled(true);
				IS.winOPS.show();
				}
			catch (Exception ec)
				{
				IS.winCON.setEnabled(true);
				IS.createWinErr(ec.toString()).show();
				}
			}
		else
			if (source.getLabel().equals("Inserisci Server nel Sistema"))
				{
				IS.winCON.setEnabled(false);
				IS.winADDR.show();
				}
			else
				if (source.getLabel().equals("ESCI"))
					{
					IS.winCON.dispose();
					IS.winLOG.dispose();
					IS.winSRVLOG.dispose();
					IS.stop();
					}
		}
	}
	
class GestButtonADDR implements ActionListener
	{
	private InterfaceServer IS;	
	GestButtonADDR (InterfaceServer t)
		{IS=t;}
	public void actionPerformed(ActionEvent e)
		{
		IS.IPaddrInsert=IS.tfADDR.getText(); //nessun controllo!!!!!!!!!
		try {
			IS.winADDR.dispose();
			ThreadInit ti=new ThreadInit(InetAddress.getByName(IS.IPaddrInsert), IS.HostConfig);
			Log.netLogging("Init Server....");
			ti.start();
			ti.join();
			if (ti.isInsert())
				{//inserimento avvenuto
				IS.winCON.dispose();
				IS.winCON.setEnabled(true);
				IS.winOPS.show();
				}
			else
				{
				IS.winCON.setEnabled(true);
				IS.winCON.show();
				}
				}//end try
		catch (Exception ec)
			{
			IS.winCON.setEnabled(true);
			IS.createWinErr(ec.toString()).show();
			}
		}
	}
	
class GestButtonOPS implements ActionListener
	{
	private InterfaceServer IS;	
	GestButtonOPS(InterfaceServer t)
		{IS=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Disconnetti server"))
			{
			IS.HostConfig.Halted();
			Log.netLogging(IS.getName()+": all daemon killed");
			IS.winOPS.dispose();
			IS.winLOG.dispose();
			IS.winSRVLOG.dispose();
			IS.stop();
			}
		else
			if (source.getLabel().equals("Inserisci nuovo volo"))
				{
				IS.winOPS.dispose();
				IS.winINS.show();
				}
			else
				if (source.getLabel().equals("Cancella volo effettuato"))
					{
					IS.winOPS.dispose();
					IS.winDEL.show();
					}
		}
	}
	
	
class GestButtonINS implements ActionListener
	{
	private InterfaceServer IS;	
	GestButtonINS (InterfaceServer t)
		{IS=t;}
	public void actionPerformed(ActionEvent e)
		{
		try {
		IS.winINS.setEnabled(false);
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("OK"))
			{
			MsgInsertFly smsg=new MsgInsertFly(new FlightKey(Long.parseLong(IS.tfcodeINS.getText())), IS.tfpartINS.getText(), IS.tfarrINS.getText(), new Date(IS.tfdatINS.getText()), InetAddress.getLocalHost().getHostAddress());
			ThreadDB td=new ThreadDB(IS.HostConfig, smsg);
			td.start();
			Log.srvLogging("Request for insert fly.....");
			td.join();
			Log.srvLogging("Insert fly OK");
			IS.winINS.dispose();
			IS.winINS.setEnabled(true);
			IS.winOPS.show();
			}
		else
			if (source.getLabel().equals("ANNULLA"))
				{
				IS.winINS.dispose();
				IS.winINS.setEnabled(true);
				IS.winOPS.show();
				}
			}
		catch (Exception ec)
			{
			IS.winINS.setEnabled(true);
			IS.createWinErr(ec.toString()).show();
			}
		}
	}
	
class GestButtonDEL implements ActionListener
	{
	private InterfaceServer IS;	
	GestButtonDEL (InterfaceServer t)
		{IS=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		try {
		IS.winDEL.setEnabled(false);
		if (source.getLabel().equals("OK"))
			{
			MsgDeleteFly smsg=new MsgDeleteFly(new FlightKey(Long.parseLong(IS.tfcodeDEL.getText())), InetAddress.getLocalHost().getHostAddress());
			ThreadDB td=new ThreadDB(IS.HostConfig, smsg);
			td.start();
			Log.srvLogging("Request for delete fly.....");
			td.join();
			Log.srvLogging("Delete fly OK");
			IS.winDEL.dispose();
			IS.winDEL.setEnabled(true);
			IS.winOPS.show();
			}
		else
			if (source.getLabel().equals("ANNULLA"))
				{
				IS.winDEL.dispose();
				IS.winDEL.setEnabled(true);
				IS.winOPS.show();
				}
			}
		catch (Exception ec)
			{
			IS.winDEL.setEnabled(true);
			IS.createWinErr(ec.toString()).show();
			}
		}
	}
	
class GestEs implements ActionListener
	{
	Frame del;
	GestEs(Frame f)						{del=f;}
	public void actionPerformed(ActionEvent e)		{del.dispose();}
	}
	