//ult. rev. 28/7/2000
//IMPLEMENTA IL PROCESSO DI INSERIMENTO DI UN NUOVO SERVER NEL SISTEMA
import java.net.*;

public class ThreadInsert extends Thread
	{
	private Socket NewSock;		//socket di connessione con il nuovo server
	private ServerConfig HostConfig;	//riferimento alla configurazione del server
	
	ThreadInsert(Socket s, ServerConfig c)	{super("Thread-INSERT"); NewSock=s; HostConfig=c;}
	public void run()
		{
		State crash=HostConfig.getCrash();
		State ins=HostConfig.getCooIns();
		synchronized(crash)	{
		synchronized(ins)	{
			if (crash.isOn())		
				Log.netLogging(getName()+" request insert loose");	
			else //isOff
				{
				ins.TurnOn();
				Log.netLogging("(! ! !) "+getName()+": Server INSERT-ON");
				}
			}}
		Log.netLogging(getName()+": distribuited insert request");
		Log.netLogging(getName()+": ......");
		DistribuitedInsert di=new DistribuitedInsert(NewSock, HostConfig);
		di.start();
		try {di.join();}
		catch (InterruptedException e) {/*ignored*/}
		synchronized(ins)	{ins.TurnOff();}
		Log.netLogging("(! ! !) "+getName()+": Server INSERT-OFF");
		Log.netLogging(getName()+": distribuited insert end");
		}
	}
					