//ult. ver. 28/07/2000
//IMPLEMENTA LA RICHIESTA DISTRIBUITE DI INSERIMENTO
import java.net.*;
import java.io.IOException;

public class DistribuitedInsert extends Thread
	{
	private Socket NewSock;				//socket connessione con nuovo server
	private ServerConfig HostConfig;		//riferimento alla configurazione del server
	DistribuitedInsert(Socket s, ServerConfig c)	
		{super("Distribuited-Insert"); NewSock=s; HostConfig=c;}
	public void run()
		{
		State hold=HostConfig.getHold();
		State unic=HostConfig.getUnic();
		State crash=HostConfig.getCrash();
		boolean first=false;
		synchronized(hold)	{
		synchronized(unic)	{
		synchronized(crash)	{
			if (crash.isOn())
				{
				Log.netLogging("#############################################");
				Log.netLogging("#### "+getName()+": SYSTEM HALTED #####");
				Log.netLogging("#############################################");
				HostConfig.Halted();
				stop();
				}
			else	//isOff
				if (unic.isOn())	first=true;
				else			first=false;
			hold.TurnOn();
			Log.netLogging("(! ! !) "+getName()+": Server HOLD-ON");
			}}}
		try {
			if (first)
				{
				Socket NewSock2=new Socket(NewSock.getInetAddress(), CServer.PORTNEW);
				Log.netLogging(getName()+": request connection at new predecessor");
				Log.netLogging("%% "+NewSock2.toString());
				CoordinatorFirst cf=new CoordinatorFirst(NewSock, NewSock2, HostConfig);
				cf.start();
				try {cf.join();}
				catch (InterruptedException e) {/*ignored*/}
				synchronized(hold)	{
				synchronized(unic)	{
					unic.TurnOff();
					hold.TurnOff();
					}}
				Log.netLogging("(! ! !) "+getName()+": Server UNIC-OFF");
				Log.netLogging("(! ! !) "+getName()+": Server HOLD-OFF");
				}
			else
				{
				CoordinatorNext cn=new CoordinatorNext(NewSock, HostConfig);
				cn.start();
				try {cn.join();}
				catch (InterruptedException e) 	{/*ignored*/}
				synchronized(hold)		{hold.TurnOff();}
				Log.netLogging("(! ! !) "+getName()+": Server HOLD-OFF");
				}
		}//end try
		catch (IOException e)	{Log.netLogging("($$$) "+getName()+": "+e);}
		}
	}
							