import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Date;

public class InterfaceClient extends Thread
	{
	InterfaceClient() {super("INTERFACE CLIENT");}
	
	protected Frame winNC;
		protected TextField tfnameNC;
		protected TextField tfcodeNC;
		protected TextField tfaddrNC;
	protected Frame winOP;
	
	protected Frame winCF;
		protected List lstflyCF;
		protected FlightKey flykey;
	protected Frame winCS;
		protected TextArea tamsgCS;
		protected Checkbox[][] cbseatsCS;
	protected Frame winDF;
		protected List lstflyDF;
	protected Frame winDS;
		protected TextArea tamsgDS;
		protected Checkbox[][] cbseatsDS;
		
	protected String IPaddrServ;
	protected Socket SockServ;
	protected ObjectInputStream ServRD;
	protected ObjectOutputStream ServWR;
	protected ClientKey CodC;
	protected String Name;
	protected FlightAttrib[] ListF;
	protected FlightAttrib[] ListFC;
	protected int[] ListS;
	protected int RowS;
	protected int NumS;
	protected boolean validListF=false;
	
	public synchronized void setValidList(boolean b)		{validListF=b;}
	
	public String ResponseForClient(boolean b)
		{
		if (b)			return("Successeful");
		else			return("Fail");
		}
	
	private String createNSpace(int y)
		{
		char[] s=new char[y];
		for (int i=0; i<y; i++)
			s[i]='_';
		return new String(s);
		}
		
	protected Frame createWinErr(String s)
		{
		Frame f=new Frame();
		f.setLocation(200,200);
		f.setSize(300,100);
		f.setBackground(Color.red);
		f.setLayout(new BorderLayout());
		f.setFont(new Font("TimensRomans", Font.BOLD, 16));
		Button bok=new Button("OK");
		GestE hand=new GestE(f);
		bok.addActionListener(hand);
		Label lerr=new Label(s, Label.CENTER);
		f.add("Center", lerr);
		f.add("South", bok);
		return f;
		}
		
	public void createWinNC()
		{
		//finestra inserimento nome e codice
		winNC=new Frame("AUTORIZZAZIONE CLIENTE");
		winNC.setLocation(200,200);
		winNC.setSize(420,300);
		winNC.setResizable(false);
		winNC.setLayout(new GridLayout(5,2,20,25));
		winNC.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winNC.setBackground(new Color(0, 205, 255));
		Label lnameNC=new Label("NOME", Label.CENTER);
		Label lcodeNC=new Label("CODICE", Label.CENTER);
		Label laddrNC=new Label("Host Connection", Label.CENTER);
		laddrNC.setFont(new Font("TimesRomans", Font.ITALIC, 14));
		Button bregNC=new Button("Registra");
		Button bescNC=new Button("Esci");
		GestButtonNC bhandleNC=new GestButtonNC(this);
		bregNC.addActionListener(bhandleNC);
		bescNC.addActionListener(bhandleNC);
		tfnameNC=new TextField(30);
		tfnameNC.setBackground(Color.white);
		tfcodeNC=new TextField(19);
		tfcodeNC.setBackground(Color.white);
		tfaddrNC=new TextField("192.168.0.");
		tfaddrNC.setBackground(Color.white);
		tfaddrNC.setFont(new Font("TimesRomans", Font.ITALIC, 14));
		winNC.add(new Label(" "));
		winNC.add(new Label(" "));
		winNC.add(lcodeNC);
		winNC.add(tfcodeNC);
		winNC.add(lnameNC);
		winNC.add(tfnameNC);
		winNC.add(laddrNC);
		winNC.add(tfaddrNC);
		winNC.add(bregNC);
		winNC.add(bescNC);
		}
		
	public void createWinOP()
		{
		//finestra principale
		winOP=new Frame("PRENOTAZIONE VOLI AEREI");
		winOP.setLocation(200,200);
		winOP.setSize(400,250);
		winOP.setLayout(new BorderLayout());
		winOP.setResizable(false);
		winOP.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winOP.setBackground(new Color(0, 205, 255));
		Label apnameOP=new Label("PRENOTAZIONI AEREE", Label.CENTER);
		apnameOP.setFont(new Font("TimesRomans", Font.BOLD, 34));
		Button bbookOP=new Button("Prenotazione voli");
		Button bdelOP=new Button("Modifica prenotazioni");
		Button bescOP=new Button("Esci");
		GestButtonOP bhandleOP=new GestButtonOP(this);
		bbookOP.addActionListener(bhandleOP);
		bdelOP.addActionListener(bhandleOP);
		bescOP.addActionListener(bhandleOP);
		Panel pbuttonOP=new Panel(new GridLayout(3,1));
		pbuttonOP.add(bbookOP);
		pbuttonOP.add(bdelOP);
		pbuttonOP.add(bescOP);
		winOP.add("Center", apnameOP);
		winOP.add("South", pbuttonOP);
		}
		
	public void createWinCF()
		{
		//finestra prenotazione di scelta volo
		winCF=new Frame("VOLI DISPONIBILI - scegli volo su cui prenotare");
		winCF.setLocation(100,50);
		winCF.setSize(700,600);
		winCF.setLayout(new BorderLayout());
		winCF.setResizable(false);
		winCF.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winCF.setBackground(new Color(0, 205, 255));
		Label campflyCF=new Label("Codice volo___________Partenza____________Arrivo______________Data_____________");
		campflyCF.setFont(new Font("TimesRoman", Font.PLAIN, 18));
		lstflyCF=new List(20, false);
		GestListCF lsthandleCF=new GestListCF(this);
		lstflyCF.addMouseListener(lsthandleCF);
		for (int i=0; i<ListF.length; i++)
			{
			String s=String.valueOf(ListF[i].getFlightKey().getKey());
			s=s.concat(createNSpace(20-s.length()));
			s=s.concat(ListF[i].getArrive());
			s=s.concat(createNSpace(40-s.length()));
			s=s.concat(ListF[i].getLeave());
			s=s.concat(createNSpace(60-s.length()));
			s=s+ListF[i].getStartDate().getDay();
			s=s.concat("-");
			s=s+ListF[i].getStartDate().getMonth();
			s=s.concat("-");
			s=s+ListF[i].getStartDate().getYear();
			s=s.concat(" at ");
			s=s+ListF[i].getStartDate().getHours();
			s=s.concat(":");
			s=s+ListF[i].getStartDate().getMinutes();
			lstflyCF.add(s);
			}
		Button bbackCF=new Button("Indietro");
		bbackCF.setFont(new Font("TimesRomans", Font.BOLD, 18));
		GestButtonCF bhandleCF=new GestButtonCF(this);
		bbackCF.addActionListener(bhandleCF);
		winCF.add("North", campflyCF);
		winCF.add("Center", lstflyCF);
		winCF.add("South", bbackCF);
		}
		
	public void createWinCS()
		{
		//finestra prenotazione di scelta posto
		winCS=new Frame("POSTI DISPONIBILI - scegli posti da prenotare");
		winCS.setLocation(200,10);
		winCS.setLayout(new BorderLayout());
		winCS.setSize(450,700);
		winCS.setResizable(false);
		winCS.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winCS.setBackground(new Color(0, 205, 255));
		tamsgCS=new TextArea();
		tamsgCS.setBackground(Color.white);
		Panel seatsCS=new Panel(new FlowLayout());
		cbseatsCS=new Checkbox[RowS][NumS];
		for (int i=0; i<RowS; i++)
			for (int j=0; j<NumS; j++)
				{
				cbseatsCS[i][j]=new Checkbox();
				cbseatsCS[i][j].setLabel(i+" - "+j);
				cbseatsCS[i][j].setEnabled(false);
				cbseatsCS[i][j].setBackground(Color.red);
				cbseatsCS[i][j].setState(true);
				}
		for (int y=0; y<ListS.length; y=y+2)
			{
			cbseatsCS[ListS[y]][ListS[y+1]]=new Checkbox();
			cbseatsCS[ListS[y]][ListS[y+1]].setLabel(ListS[y]+" - "+ListS[y+1]);
			cbseatsCS[ListS[y]][ListS[y+1]].setState(false);
			cbseatsCS[ListS[y]][ListS[y+1]].setEnabled(true);
			cbseatsCS[ListS[y]][ListS[y+1]].setBackground(new Color(0, 205, 255));
			}
		for (int i=0; i<RowS; i++)
			for (int j=0; j<NumS; j++)
				seatsCS.add(cbseatsCS[i][j]);
		Panel pbuttonCS=new Panel(new GridLayout(5,1,0,20));
		Button bbackCS=new Button("Indietro");
		Button bbookCS=new Button("Prenota");
		GestButtonCS bhandleCS=new GestButtonCS(this);
		bbackCS.addActionListener(bhandleCS);
		bbookCS.addActionListener(bhandleCS);
		pbuttonCS.add(new Label(" "));
		pbuttonCS.add(bbookCS);
		pbuttonCS.add(new Label(" "));
		pbuttonCS.add(bbackCS);
		winCS.add("East", pbuttonCS);
		winCS.add("Center", seatsCS);
		winCS.add("South", tamsgCS);
		}
		
	public void createWinDF()
		{
		//finestra cancellazione
		winDF=new Frame("VOLI CON PRENOTAZIONI - scegli volo da cui cancellare delle prenotazioni");
		winDF.setLocation(100,50);
		winDF.setSize(700,300);
		winDF.setLayout(new BorderLayout());
		winDF.setResizable(false);
		winDF.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winDF.setBackground(new Color(0, 205, 255));
		Label campflyDF=new Label("Codice volo___________Partenza____________Arrivo______________Data____________");
		campflyDF.setFont(new Font("TimesRoman", Font.PLAIN, 18));
		lstflyDF=new List(20, false);
		GestListDF lsthandleDF=new GestListDF(this);
		lstflyDF.addMouseListener(lsthandleDF);
		for (int i=0; i<ListFC.length; i++)
			{
			String s=String.valueOf(ListFC[i].getFlightKey().getKey());
			s=s.concat(createNSpace(20-s.length()));
			s=s.concat(ListFC[i].getArrive());
			s=s.concat(createNSpace(40-s.length()));
			s=s.concat(ListFC[i].getLeave());
			s=s.concat(createNSpace(60-s.length()));
			s=s+ListFC[i].getStartDate().getDay();
			s=s.concat("-");
			s=s+ListFC[i].getStartDate().getMonth();
			s=s.concat("-");
			s=s+ListFC[i].getStartDate().getYear();
			s=s.concat(" at ");
			s=s+ListFC[i].getStartDate().getHours();
			s=s.concat(":");
			s=s+ListFC[i].getStartDate().getMinutes();
			lstflyDF.add(s);
			}
		Button bbackDF=new Button("Indietro");
		bbackDF.setFont(new Font("TimesRomans", Font.BOLD, 18));
		GestButtonDF bhandleDF=new GestButtonDF(this);
		bbackDF.addActionListener(bhandleDF);
		winDF.add("North", campflyDF);
		winDF.add("Center", lstflyDF);
		winDF.add("South", bbackDF);
		}
		
	public void createWinDS()
		{
		winDS=new Frame("POSTI PRENOTATI - scegli posti prenotati da cancellare");
		winDS.setLocation(200,10);
		winDS.setLayout(new BorderLayout());
		winDS.setSize(450,700);
		winDS.setResizable(false);
		winDS.setFont(new Font("TimesRomans", Font.PLAIN, 16));
		winDS.setBackground(new Color(0, 205, 255));
		tamsgDS=new TextArea();
		tamsgDS.setBackground(Color.white);
		Panel seatsDS=new Panel(new FlowLayout());
		cbseatsDS=new Checkbox[RowS][NumS];
		for (int i=0; i<RowS; i++)
			for (int j=0; j<NumS; j++)
				{
				cbseatsDS[i][j]=new Checkbox();
				cbseatsDS[i][j].setLabel(i+"-"+j);
				cbseatsDS[i][j].setEnabled(false);
				cbseatsDS[i][j].setBackground(new Color(0, 205, 255));
				cbseatsDS[i][j].setState(false);
				}
		for (int y=0; y<ListS.length; y=y+2)
			{
			cbseatsDS[ListS[y]][ListS[y+1]]=new Checkbox();
			cbseatsDS[ListS[y]][ListS[y+1]].setLabel(ListS[y]+"-"+ListS[y+1]);
			cbseatsDS[ListS[y]][ListS[y+1]].setEnabled(true);
			cbseatsDS[ListS[y]][ListS[y+1]].setBackground(Color.green);
			cbseatsDS[ListS[y]][ListS[y+1]].setState(true);
			}
		for (int i=0; i<RowS; i++)
			for (int j=0; j<NumS; j++)
				seatsDS.add(cbseatsDS[i][j]);
		Panel pbuttonDS=new Panel(new GridLayout(5,1,0,20));
		Button bbackDS=new Button("Indietro");
		Button bbookDS=new Button("Modifica");
		GestButtonDS bhandleDS=new GestButtonDS(this);
		bbackDS.addActionListener(bhandleDS);
		bbookDS.addActionListener(bhandleDS);
		pbuttonDS.add(new Label(" "));
		pbuttonDS.add(bbookDS);
		pbuttonDS.add(new Label(" "));
		pbuttonDS.add(bbackDS);
		winDS.add("East", pbuttonDS);
		winDS.add("Center", seatsDS);
		winDS.add("South", tamsgDS);
		}
		
	public void run()
		{
		createWinNC();
		createWinOP();
		winNC.show();
		}
		
	}
	
class GestButtonNC implements ActionListener
	{
	private InterfaceClient IC;
	GestButtonNC(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Esci"))
			IC.winNC.dispose();
		else
			if (source.getLabel().equals("Registra"))
				{
				boolean nameOK=false;
				boolean codeOK=false;
				IC.Name=IC.tfnameNC.getText();
				try {
				IC.CodC=new ClientKey(Long.parseLong(IC.tfcodeNC.getText()));
				codeOK=true;
					}
				catch (Exception ec) {}
				if (IC.Name.length()>0)		nameOK=true;
				if (!(nameOK & codeOK))
					IC.createWinErr("Inserire nome e codice corretti").show();
				else
					{
					try {
					IC.IPaddrServ=IC.tfaddrNC.getText();
					//nessun controllo!!!!!!
					IC.SockServ=new Socket(InetAddress.getByName(IC.IPaddrServ), CServer.PORTRQ);
					IC.SockServ.setSoTimeout(CServer.TIMEOUT_CLIENT);
					IC.ServWR=new ObjectOutputStream(IC.SockServ.getOutputStream());
					IC.ServWR.flush();
					IC.ServRD=new ObjectInputStream(IC.SockServ.getInputStream());
					IC.winNC.dispose();
					IC.winOP.show();
						}
					catch (InterruptedIOException ec) //scadenza del time-out
						{IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();}
					catch (Exception ec) {IC.createWinErr(ec.toString()).show();}
					}
				
				}
		}
	}
	
class GestButtonOP implements ActionListener
	{
	private InterfaceClient IC;
	GestButtonOP(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Prenotazione voli"))
			{
			IC.winOP.setEnabled(false);
			try {
			if (!IC.validListF)
				{
				//inio di un GET_FLY_LIST
				MsgGetFlyList smsg=new MsgGetFlyList();
				IC.ServWR.writeByte(Message.codeMsg("GFL"));
				IC.ServWR.writeObject(smsg);
				//attesa di un FLY_LIST
				byte typmsg=IC.ServRD.readByte();
				if (Message.decodeMsg(typmsg).equals("FL"))
					{
					MsgFlyList rmsg=(MsgFlyList) IC.ServRD.readObject();
					IC.ListF=rmsg.getList();
					CacheTh ct=new CacheTh(IC);
					ct.start();
					IC.winOP.dispose();
					IC.winOP.setEnabled(true);
					IC.createWinCF();
					IC.winCF.show();
					}
				else
					{
					Object ignored=IC.ServRD.readObject();
					IC.winOP.setEnabled(true);
					IC.createWinErr("Inconsistent Server Message").show();
					}
				}
			else
				{
				IC.winOP.dispose();
				IC.winOP.setEnabled(true);
				IC.createWinCF();
				IC.winCF.show();
				}
			}
			catch (InterruptedIOException ec) //scadenza del time-out
				{
				IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
				IC.winOP.dispose();
				IC.winOP.setEnabled(true);
				IC.winNC.show();
				try {IC.SockServ.close();}
				catch (IOException ign) {/*ignored*/}
				}
			catch (Exception ec) 
				{
				IC.winOP.setEnabled(true);
				IC.createWinErr(ec.toString()).show();
				}
			}
		else
			if (source.getLabel().equals("Modifica prenotazioni"))
				{
				IC.winOP.setEnabled(false);
				try{
				//preparazione e invio GET_CLIENT_FLY_LIST
				MsgGetClientFlyList smsg=new MsgGetClientFlyList(IC.CodC);
				IC.ServWR.writeByte(Message.codeMsg("GCFL"));
				IC.ServWR.writeObject(smsg);
				//attesa del FLY_LIST
				byte typmsg=IC.ServRD.readByte();
				if (Message.decodeMsg(typmsg).equals("FL"))
					{
					MsgFlyList rmsg=(MsgFlyList) IC.ServRD.readObject();
					IC.ListFC=rmsg.getList();
					IC.winOP.dispose();
					IC.winOP.setEnabled(true);
					IC.createWinDF();
					IC.winDF.show();
					}
				else
					{
					Object ignored=IC.ServRD.readObject();
					IC.winOP.setEnabled(true);
					IC.createWinErr("Inconsistent Server Message").show();
					}
				}
				//scadenza del time-out
				catch (InterruptedIOException ec) 
					{
					IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
					IC.winOP.dispose();
					IC.winOP.setEnabled(true);
					IC.winNC.show();
					try {IC.SockServ.close();}
					catch (IOException ign) {/*ignored*/}
					}
				catch (Exception ec) 	
					{
					IC.winOP.setEnabled(true);
					IC.createWinErr(ec.toString()).show();
					}
				}
			else
				if (source.getLabel().equals("Esci"))
					{
					IC.winOP.dispose();
					try {IC.SockServ.close();}
					catch (IOException ign) {/*ignored*/}
					IC.stop();
					}
		}
	}
	
class GestButtonCF implements ActionListener
	{
	private InterfaceClient IC;
	GestButtonCF(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Indietro"))
			{
			IC.winCF.dispose();
			IC.winOP.show();
			}
		}
	}
	
class GestListCF extends MouseAdapter
	{
	private InterfaceClient IC;
	GestListCF(InterfaceClient t)
		{IC=t;}
	public void mouseClicked(MouseEvent e)
		{
		if (e.getClickCount()==2)
			{
			IC.winCF.setEnabled(false);
			List source=(List) e.getSource();
			int cfly=source.getSelectedIndex();
			IC.flykey=IC.ListF[cfly].getFlightKey();
			try {
				//preparazione e invio GET_FREE_SEAT
				MsgGetFreeSeat smsg=new MsgGetFreeSeat(IC.flykey);
				IC.ServWR.writeByte(Message.codeMsg("GFS"));
				IC.ServWR.writeObject(smsg);
				//attesa di SEAT_LIST
				byte typmsg=IC.ServRD.readByte();
				if (Message.decodeMsg(typmsg).equals("SL"))
					{
					MsgSeatList rmsg=(MsgSeatList) IC.ServRD.readObject();
					IC.ListS=rmsg.getList();
					IC.RowS=rmsg.getNumR();
					IC.NumS=rmsg.getNumN();
					IC.winCF.dispose();
					IC.winCF.setEnabled(true);
					IC.createWinCS();
					IC.winCS.show();
					}
				else
					{
					Object ignored=IC.ServRD.readObject();
					IC.winCF.setEnabled(true);
					IC.createWinErr("Inconsistent Server Message").show();
					}
			}
			//scadenza del time-out
			catch (InterruptedIOException ec) 
				{
				IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
				IC.winCF.dispose();
				IC.winCF.setEnabled(true);
				IC.winNC.show();
				try {IC.SockServ.close();}
				catch (IOException ign) {/*ignored*/}
				}
			catch (Exception ec) 
				{
				IC.winCF.setEnabled(true);
				IC.createWinErr(ec.toString()).show();
				}
			}
		}
	}
	
class GestButtonDF implements ActionListener
	{
	private InterfaceClient IC;
	GestButtonDF(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Indietro"))
			{
			IC.winDF.dispose();
			IC.winOP.show();
			}
		}
	}

class GestButtonCS implements ActionListener
	{
	private InterfaceClient IC;	
	GestButtonCS(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Indietro"))
			{
			IC.winCS.dispose();
			IC.winCF.show();
			}
		else
			if (source.getLabel().equals("Prenota"))
				{
				boolean err=false;
				IC.winCS.setEnabled(false);
				IC.tamsgCS.append("Attendere richiesta in atto.......\n");
				for (int i=0; i<IC.RowS; i++)
					for (int j=0; j<IC.NumS; j++)
						if (IC.cbseatsCS[i][j].getState() & IC.cbseatsCS[i][j].isEnabled())
							{
							try {
							//prepearazione e invio di BOOKING_THIS
							MsgBookingThis smsg=new MsgBookingThis(IC.flykey, i, j, new ClientAttrib(IC.CodC, IC.Name));
							IC.ServWR.writeByte(Message.codeMsg("BT"));
							IC.ServWR.writeObject(smsg);
							//attesa risposta RESPONSE
							byte typmsg=IC.ServRD.readByte();
							if (Message.decodeMsg(typmsg).equals("RSP"))
								{
								MsgResponse rmsg=(MsgResponse) IC.ServRD.readObject();
								IC.tamsgCS.append("FLY: "+String.valueOf(rmsg.getFlyId().getKey())+" SEAT: "+rmsg.getSeat()[0]+"-"+rmsg.getSeat()[1]+"  "+rmsg.getDescription()+" >>> "+IC.ResponseForClient(rmsg.isSuccesseful())+"\n");
								}
							else
								{
								Object ignored=IC.ServRD.readObject();
								IC.winCS.setEnabled(true);
								IC.createWinErr("Inconsistent Server Message").show();
								err=true;
								}
							}
							//scadenza del time-out
							catch (InterruptedIOException ec) 
								{
								IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
								IC.winCS.dispose();
								IC.winCS.setEnabled(true);
								IC.winNC.show();
								try {IC.SockServ.close();}
								catch (IOException ign) {/*ignored*/}
								err=true;
								}	
							catch (Exception ec)	
								{
								IC.winCS.setEnabled(true);
								IC.createWinErr(ec.toString()).show();
								err=true;
								}
							}
				if (!err)
					{
					try {IC.sleep(2500);}
					catch (Exception ecc) {/*ignored*/}
					IC.winCS.dispose();
					IC.winCS.setEnabled(true);
					IC.winCF.show();
					err=false;
					}
				}
		}
	}

class GestListDF extends MouseAdapter
	{
	private InterfaceClient IC;
	GestListDF(InterfaceClient t)
		{IC=t;}
	public void mouseClicked(MouseEvent e)
		{
		if (e.getClickCount()==2)
			{
			IC.winDF.setEnabled(false);
			List source=(List) e.getSource();
			int cfly=source.getSelectedIndex();
			IC.flykey=IC.ListFC[cfly].getFlightKey();
			try {
				//preparazione e invio GET_CLIENT_SEAT_LIST
				MsgGetClientSeatList smsg=new MsgGetClientSeatList(IC.CodC, IC.flykey);
				IC.ServWR.writeByte(Message.codeMsg("GCSL"));
				IC.ServWR.writeObject(smsg);
				//attesa di SEAT_LIST
				byte typmsg=IC.ServRD.readByte();
				if (Message.decodeMsg(typmsg).equals("SL"))
					{
					MsgSeatList rmsg=(MsgSeatList) IC.ServRD.readObject();
					IC.ListS=rmsg.getList();
					IC.RowS=rmsg.getNumR();
					IC.NumS=rmsg.getNumN();
					IC.winDF.dispose();
					IC.winDF.setEnabled(true);
					IC.createWinDS();
					IC.winDS.show();
					}
				else
					{
					Object ignored=IC.ServRD.readObject();
					IC.winDF.setEnabled(true);
					IC.createWinErr("Inconsistent Server Message").show();
					}
			}
			//scadenza del time-out
			catch (InterruptedIOException ec) 
				{
				IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
				IC.winDF.dispose();
				IC.winDF.setEnabled(true);
				IC.winNC.show();
				try {IC.SockServ.close();}
				catch (IOException ign) {/*ignored*/}
				}
			catch (Exception ec) 
				{
				IC.winDF.setEnabled(true);
				IC.createWinErr(ec.toString()).show();
				}
			}
		}
	}
	
class GestButtonDS implements ActionListener
	{
	private InterfaceClient IC;	
	GestButtonDS(InterfaceClient t)
		{IC=t;}
	public void actionPerformed(ActionEvent e)
		{
		Button source=(Button) e.getSource();
		if (source.getLabel().equals("Indietro"))
			{
			IC.winDS.dispose();
			IC.winDF.show();
			}
		else
			if (source.getLabel().equals("Modifica"))
				{
				boolean err=false;
				IC.winDS.setEnabled(false);
				IC.tamsgDS.append("Attendere richiesta in atto.......\n");
				for (int i=0; i<IC.RowS; i++)
					for (int j=0; j<IC.NumS; j++)
						if (!(IC.cbseatsDS[i][j].getState()) & IC.cbseatsDS[i][j].isEnabled())
							{
							try {
							//prepearazione e invio di DELETE_BOOKING
							MsgDeleteBooking smsg=new MsgDeleteBooking(IC.flykey, i, j, IC.CodC);
							IC.ServWR.writeByte(Message.codeMsg("DB"));
							IC.ServWR.writeObject(smsg);
							//attesa risposta RESPONSE
							byte typmsg=IC.ServRD.readByte();
							if (Message.decodeMsg(typmsg).equals("RSP"))
								{
								MsgResponse rmsg=(MsgResponse) IC.ServRD.readObject();
								IC.tamsgDS.append("FLY: "+String.valueOf(rmsg.getFlyId().getKey())+" SEAT: "+rmsg.getSeat()[0]+"-"+rmsg.getSeat()[1]+" "+rmsg.getDescription()+" >>> "+IC.ResponseForClient(rmsg.isSuccesseful())+"\n");
								}
							else
								{
								Object ignored=IC.ServRD.readObject();
								IC.winDS.setEnabled(true);
								IC.createWinErr("Inconsistent Server Message").show();
								err=true;
								}
							}
							//scadenza del time-out
							catch (InterruptedIOException ec) 
								{
								IC.createWinErr("Il server non risponde, rieffettuare la connessione").show();
								IC.winDS.dispose();
								IC.winDS.setEnabled(true);
								IC.winNC.show();
								try {IC.SockServ.close();}
								catch (IOException ign) {/*ignored*/}
								err=true;
								}
							catch (Exception ec)	
								{
								IC.winDS.setEnabled(true);
								IC.createWinErr(ec.toString()).show();
								err=true;
								}
							}
				if (!err)
					{
					try {IC.sleep(2500);}
					catch (Exception ecc) {/*ignored*/}
					IC.winDS.dispose();
					IC.winDS.setEnabled(true);
					IC.winDF.show();
					err=false;
					}
				}
		}
	}
	
class GestE implements ActionListener
	{
	Frame del;
	GestE(Frame f)						{del=f;}
	public void actionPerformed(ActionEvent e)		{del.dispose();}
	}