public abstract class Pack
	{
	public final static int LLONG=8;
	public final static int LINTEGER=4;
	
	public static byte[] UniqueByting(byte[] a1, byte[] a2)
		{
		byte[] r=new byte[a1.length+a2.length];
		for (int i=0; i<a1.length; i++)
	r[i]=a1[i];
		for (int i=0; i<a2.length; i++)
	r[i+a1.length]=a2[i];
		return r;
		}
	public static byte[] Bytingstring(String s)
		{return UniqueByting(Bytinginteger(s.length()),s.getBytes());}
		//si impacca la lunghezza e poi la stringa!!!!!!
	public static String UnBytingstring(byte[] b)
		{
		char[] c=new char[b.length];
		for (int ind=0; ind<c.length; ind++)
			c[ind]=(char) b[ind];
		return String.valueOf(c);
		}
	public static byte[] Bytinginteger(int lp)
		{
		byte[] br=new byte[LINTEGER];
		//array di byte contenenti la scomposizione del long
		for (int i=0; i<LINTEGER; i++)
			br[i]=((byte) (lp >> 8*i));
			//assegnazione ai vari byte degli ultimo byte del long via via shiftato a destra (di 1 byte)
			//dal meno significativo in poi
		return br;
		}
	public static int UnBytinginteger(byte[] br)
		{
		int masch=255;
		// maschera di 64 bit (per i long) costituita da 00......00|11111111 (ultimo byte tutto a 1)
		int lp2=((int) br[0]) & masch;
		//mascheramento del primo byte (meno significativo) per ripulirlo dagli 1 pi significativi
		// es.  	br=>		11...11|010010110
		//	masch=>	00...00|111111111
		// 	OR ==>	00...00|010010110
		for (int i=1; i<LINTEGER; i++)
			lp2=lp2 | ((  ((int) br[i])  << 8*i ) & (masch << 8*i));
			//mascheramento del  byte successivi per ripulirli dagli 1 pi significativi
			//si schifta  la maschera e i byte
		return lp2;
		}
	public static byte[] Bytinglong(long lp)
		{
		byte[] br=new byte[LLONG];
		//array di byte contenenti la scomposizione del long
		for (int i=0; i<LLONG; i++)
			{
			br[i]=((byte) (lp >> 8*i));
			//assegnazione ai vari byte degli ultimo byte del long via via shiftato a destra (di 1 byte)
			//dal meno significativo in poi
			}
		return br;
		}
	public static long UnBytinglong(byte[] br)
		{
		long masch=255;
		// maschera di 64 bit (per i long) costituita da 00......00|11111111 (ultimo byte tutto a 1)
		long lp2=((long) br[0]) & masch;
		//mascheramento del primo byte (meno significativo) per ripulirlo dagli 1 pi significativi
		// es.  	br=>		11...11|010010110
		//	masch=>	00...00|111111111
		// 	OR ==>	00...00|010010110
		for (int i=1; i<LLONG; i++)
			lp2=lp2 | ((  ((long) br[i])  << 8*i ) & (masch << 8*i));
			//mascheramento del  byte successivi per ripulirli dagli 1 pi significativi
			//si schifta  la maschera e i byte
		return lp2;
		}
	}